

#ifndef _menudrv_h_ /* Sat Nov 25 12:23:41 1995 */
#define _menudrv_h_



/*
 *
 *          Copyright (C) 1995, M. A. Sridhar
 *  
 *
 *     This software is Copyright M. A. Sridhar, 1995. You are free
 *     to copy, modify or distribute this software  as you see fit,
 *     and to use  it  for  any  purpose, provided   this copyright
 *     notice and the following   disclaimer are included  with all
 *     copies.
 *
 *                        DISCLAIMER
 *
 *     The author makes no warranties, either expressed or implied,
 *     with respect  to  this  software, its  quality, performance,
 *     merchantability, or fitness for any particular purpose. This
 *     software is distributed  AS IS.  The  user of this  software
 *     assumes all risks  as to its quality  and performance. In no
 *     event shall the author be liable for any direct, indirect or
 *     consequential damages, even if the  author has been  advised
 *     as to the possibility of such damages.
 *
 */



#include "ui/menu.h"
#include "ui/viewdesc.h"


class MenuDriver: public CL_Object {

public:
    ~MenuDriver () {}; // Needed because Object's destructor is pure virtual
    
    void Setup   (UI_Menu*);
    // Set up this MenuDriver to work with the given Menu

    UI_ViewType  CurrentObjectType() const;
    // Return the type of SimpleVObject currently selected by the user

    // Menu event response methods:
    bool CatchAll(UI_Event&, long);
    bool Choose  (UI_Event&, long);
    bool Quit    (UI_Event&, long);
    bool About   (UI_Event&, long);
    
protected:
    UI_Menu*     _menu;
    UI_ViewID    _checkedObjectID;
};


#endif /* _menudrv_h_ */
